#include "8255.h"

// Internal oscilattor with 4xPLL
//#pragma config FOSC = IRC, PLLEN = ON
// External clock input with 4xPLL
#pragma config FOSC = ECH, PLLEN = ON

// RA3 used as I/O instead of MCLR
#pragma config MCLRE = OFF
// MISC feature, all off
#pragma config PCLKEN = OFF, FCMEN = OFF, IESO = OFF, PWRTEN = OFF, BOREN = OFF
#pragma config BORV = 30, WDTEN = OFF, WDTPS = 1, HFOFST = OFF, STVREN = OFF
#pragma config LVP = OFF, BBSIZ = OFF, XINST = OFF
// Protection, all off
#pragma config CP0 = OFF, CP1 = OFF, CPB = OFF, CPD = OFF, WRT0 = OFF, WRT1 = OFF
#pragma config WRTC = OFF, WRTB = OFF, WRTD = OFF, EBTR0 = OFF, EBTR1 = OFF, EBTRB = OFF

/*
Memory 0x100-0x1FF will be used for writing buffer,
where odd number addresses contain data,
even number addresses contain flags and addresses.
Dedicate FSR1H and FSR1L for using this buffer.
FSR1H is always 0x01.
*/
#pragma udata g_keymap=0xB0
unsigned char g_keymap[16];
#pragma udata g_wbuff=0x100
unsigned char g_wbuff[0x100];
/* global variables */
#pragma udata access accessram
unsigned near char g_key_pressed, g_cmt_out;
unsigned near char g_p_wbuff;
unsigned near char g_8255PA, g_8255PB, g_8255PC;
unsigned near char g_PORTA,g_PORTC;
static unsigned near char g_temp1,g_temp2;
unsigned near char g_555_reset;
#pragma udata

void blink(static unsigned char num){
	static unsigned int i;
	static unsigned char j,k;
	LATBbits.LATB6=!LATBbits.LATB6;
	for(j=0;j<10;j++){for(i=0;i<65535;i++);}
	for(k=0;k<num;k++){
		LATBbits.LATB6=!LATBbits.LATB6;
		for(j=0;j<2;j++){for(i=0;i<65535;i++);}
		LATBbits.LATB6=!LATBbits.LATB6;
		for(j=0;j<2;j++){for(i=0;i<65535;i++);}
	}
	LATBbits.LATB6=!LATBbits.LATB6;
}
void error(){
	do {
		blink(3);
	} while(1);
}

#pragma code hpInt=0x08
void hpInt(){
_asm
	// High priolity interrupt is used for "RD" signal
	BTFSS PORTA,3,ACCESS // chech A1
	BRA RD_E000_E001
	BTFSS PORTA,2,ACCESS // check A0
	BRA RD_E002
	BCF INTCON,1,ACCESS  // Interrupt flag is cleared
	RETFIE 1             // Ignore the reading from E003
	NOP
	NOP
	// Low priolity interrupt is used for "WR" signal
	MOVFF PORTA, POSTINC1
	MOVFF PORTC, POSTINC1 // This must be done within 7 cycles
//	BTFSC PORTA,1,ACCESS  // checking error for debug
//	GOTO error            // checking error for debug
	BCF FSR1H,1,ACCESS    // FSR1H must be 0x10
	BSF FSR1H,0,ACCESS    // FSR1H must be 0x10
	BCF INTCON3,0,ACCESS  // Interrupt flag is cleared
	RETFIE 0
RD_E002:
	// Read PC
	MOVFF g_8255PC,LATC
	CLRF TRISC, ACCESS
	BCF INTCON, 1,ACCESS   // Interrupt flag is cleared
WAIT_RD:
	BTFSS PORTA, 0, ACCESS // "RD" line is connected to RA0
	BRA WAIT_RD            // Wait until "RD" line rise up
	SETF TRISC, ACCESS
	RETFIE 1
RD_E000_E001:
	BTFSC PORTA,2,ACCESS // check A0
	BRA RD_E001
	// Read PA
	MOVFF g_8255PA,LATC
	CLRF TRISC,ACCESS
	BCF INTCON, 1,ACCESS   // Interrupt flag is cleared
	BTFSS PORTA, 0, ACCESS // "RD" line is connected to RA0
	BRA WAIT_RD            // Wait until "RD" line rise up
	SETF TRISC, ACCESS
	RETFIE 1
RD_E001:
	// Read PB
	MOVFF g_8255PB,LATC
	CLRF TRISC,ACCESS
	BCF INTCON, 1,ACCESS   // Interrupt flag is cleared
	BTFSS PORTA, 0, ACCESS // "RD" line is connected to RA0
	BRA WAIT_RD            // Wait until "RD" line rise up
	SETF TRISC, ACCESS
	RETFIE 1
_endasm
}

void checkBuffer(){
	// This routine must be faster later!
	// Wrting by assember and using it as inline-macro must be better!
	while(g_p_wbuff!=FSR1L){
		// Request(s) from Z80 to 8255 has(have) been received.
		g_temp1=g_wbuff[g_p_wbuff++];
		g_temp2=g_wbuff[g_p_wbuff++];
		switch(g_temp1&0x0c){
			case 0x00: // 8255PA is an output port
				g_8255PA=g_temp2;
				g_8255PB=g_keymap[g_8255PA&0x0F];
				break;
			case 0x04: // 8255PB is an input port
				break;
			case 0x08: // 8255PC; lower 4 bits are used for output
				g_8255PC=g_8255PC&0xF0 | g_temp2&0x0F;
				break;
			default:   // 8255 control word
				if (g_temp2 & 0x80) break; // ignore port setting
				switch (g_temp2 & 0x0E) { // PORTC bit settings
					case 0x00:
						// V-gate control
						if (g_temp2 & 0x01) {bset(g_8255PC,0);}//g_8255PC=g_8255PC | 0x01;
						else bclear(g_8255PC,0);//g_8255PC=g_8255PC & 0xFE;
						break;
					case 0x02:
						// Casette out
						LATBbits.LATB4=1;
						if (g_temp2 & 0x01) {
							bset(g_8255PC,1);//g_8255PC=g_8255PC | 0x02;
							TRISBbits.TRISB4=0;
						} else {
							bclear(g_8255PC,1);//g_8255PC=g_8255PC & 0xFD;
							TRISBbits.TRISB4=1;
						}
						break;
					case 0x04:
						// Green/red LED control
						if (g_temp2 & 0x01) {bset(g_8255PC,2);}//g_8255PC=g_8255PC | 0x04;
						else bclear(g_8255PC,2);//g_8255PC=g_8255PC & 0xFB;
						break;
					case 0x06:
						// Motor control
						if (g_temp2 & 0x01) {
							// Toggle FF for CMT motor
							if (g_8255PC & 0x08) {btoggle(g_8255PC,4);}//g_8255PC=g_8255PC^0x10;
							else bset(g_8255PC,3);//g_8255PC=g_8255PC | 0x08;
						} else bclear(g_8255PC,3);//g_8255PC=g_8255PC & 0xF7;
						break;
					default:
						break;
				}
				break;
		}
	}
	// Read from casette tape
	if (g_8255PC&0x10) {
		if (TRISBbits.TRISB4) {
			if (!ADCON0bits.GO) {
				if (5<ADRESH) {bset(g_8255PC,5);}//g_8255PC|=0x20;
				else bclear(g_8255PC,5);//g_8255PC&=0xDF;
				// Read again.
				ADCON0=0x2B;
			}
		}
	}
}

/*
RA0 (INT0) RD input
RA1 (INT1) WR input
RA2-RA3    A0-A1 input
RA4        V-blank input
RA5        LED (green/red) input
RB4        Casette-tape I/O
RB5 (RX)   EUSART communication with 18F14K50
RB6        V-gate output
RB7 (TX)   EUSART communication with 18F14K50
RC0-RC7    D0-D7 I/O
*/
#pragma udata access accessram
void main(){
	static near unsigned char i;
	static near unsigned char tmr1u;
	static near unsigned char prevKeyStatus;

	/* Prepare PIC environment */
	// 16 MHz internal oscillator with 4xPLL
	//OSCCON=0x7D;
	// PORTA, all input //except for RA5
	TRISA=0xFF;
	// PORTB, all input except for RB6 and RB7, at the beginning
	TRISB=0x3F;
	// PORTC, all input at the beginning
	TRISC=0xFF;
	// All degital except for AN10 (used for casette input)
	ANSELH=0x00;
	ANSEL=0x00;
	ANSELHbits.ANS10=1;

	// High priority iterrupt on falling RA0
	// Low priority interrupt on falling RA1
	RCONbits.IPEN=1;
	INTCON2bits.INTEDG0=0;
	INTCON2bits.INTEDG1=0;
	INTCON=0xD0;// GIE=1,PEIE=1,TMR0IE=0,INT0IE=1,RABIE=0
	INTCON3=0x08;// INT2IP=0,INT1IP=0,INT2IE=0,INT1IE=1

	// Timer0 is used for cursor blinking
	T0CON=0x86;
	INTCONbits.TMR0IF=0;

	// Timer1 is used for events every 16 msec.
	T1CON=0xB5;
	PIR1bits.TMR1IF=0;

	// A/D converter (AN10) is used to get data from casette tape
	ADCON1=0x00; // Use +5V and 0V as references
	ADCON2=0x43; // 8 Tad to get signal, Fosc/64, left justified
	ADCON0=0x2B; // Use AN10, GO=1, ADON=1 (use the same setteing before reading)
	
	/* init */
	eusart_init();
	tmr1u=0;

	// Clear buffer
	i=0;
	do {
		g_wbuff[i++]=0;
	} while(i);
	g_p_wbuff=0;
	FSR1H=0x01;
	FSR1L=0x00;

	// Clear keymap
	clearKeyMap();

	// Clear ports
	g_8255PA=g_8255PB=g_8255PC=0;
	g_key_pressed=g_cmt_out=0;

	/* main loop */
	i=0;
	do {
		checkBuffer();
		// Emulate 555 timer
		if (INTCONbits.TMR0IF) {
			INTCONbits.TMR0IF=0;
			// Toggle 555 status
			btoggle(g_8255PC,6);
			// Key press check
			if (g_key_pressed) {
				g_key_pressed=0;
			} else {
				// Key signal was not received for 0.7 sec.
				// So, let's clear key map.
				clearKeyMap();
			}
			// End of casette out check
			if (g_cmt_out) {
				g_cmt_out=0;
			} else {
				// Turn to reading mode
				TRISBbits.TRISB4=1;
			}
		}

		checkBuffer();
		// Reset 555 timer
		if (!(g_8255PA&0x80)) {
			TMR0H=0;
			TMR0L=0;
			_asm BCF g_8255PC,6,ACCESS _endasm
		}

		checkBuffer();
		// Read Vsync
		if (PORTAbits.RA4) {_asm BSF g_8255PC,7,ACCESS _endasm}
		else {_asm BCF g_8255PC,7,ACCESS _endasm}

		//checkBuffer();
		// LED
		// Send signal to PIC18F14K50 here

		checkBuffer();
		// V-gate
		if (g_8255PC&0x01) LATBbits.LATB6=1;
		else LATBbits.LATB6=0;
		
		checkBuffer();
		// Serial comunication with 18F14K50
		eusart_events();

		checkBuffer();
		if (PIR1bits.TMR1IF) {
			PIR1bits.TMR1IF=0;
			// events every 16 msec.
			g_temp1=g_8255PC&0x04;            // Green-Red LED
			if (g_8255PC&0x10) g_temp1|=0x01; // motor
			if (prevKeyStatus!=g_temp1) eusart_send(g_temp1); // 0x00 - 0x0F
			prevKeyStatus=g_temp1;
			if (62<++tmr1u) {
				tmr1u=0;
				// events every 1 sec
				eusart_send(prevKeyStatus);
			}
		}

	} while(1);	
}


