#include "cg.h"

#pragma romdata monitorrom=0x4000
#include "monitorrom.h"

#define write video

void monitorROM(){
	unsigned char a03,a49,a1011;
	unsigned int addr;
	// Reset Z80
	LATA=0x00;
	TRISA=0x80;
	ANSELA=0x80;
	// Disable writing
	LATB=0x80;
	write=1;
	TRISB=0x01;
	ANSELB=0x01;
	// Use PORTC for writing
	LATC=0x00;
	TRISC=0x00;
	ANSELC=0x00;

	/*
	RE3 (MCLR) Reset input
	RB0 (INT0) chip enable (and write)
	RB1-RB6    A4-A9
	RA0-RA3    A0-A3
	RC0-RC7    D0-D7
	RB7        video (WR for ROM generation)
	RA4        Hsync (A10 for ROM generation)
	RA5        Vsync (A11) for ROM generation)
	RA6        Reset output
	RA7 (CLKI) clock input
	*/
	
	// Copy memory from PIC programming memory to RAM
	addr=0;
	a03=a49=a1011=0;
	do {
		write=1;
		LATC=monitorrom[addr];
		LATA=(a1011<<4) | a03;
		LATB=(a49<<1) | (LATB & 0x81);
		a03++;
		if (15<a03) {
			a03=0;
			a49++;
			if (63<a49) {
				a49=0;
				a1011++;
			}
		}
		write=0;
	} while ((++addr)<0x1000);
	write=1;

	// Set all IO for input
	ANSELC=0xFF;
	TRISC=0xFF;
	ANSELB=0xFF;
	TRISB=0xFF;
	ANSELA=0xBF;
	TRISA=0xBF;

	// Disable reset
	LATA=0xFF;
}