#include "kmz80usb.h"

#pragma config CPUDIV = NOCLKDIV, USBDIV = OFF, FOSC = HS, PLLEN = ON, PCLKEN = ON
#pragma config FCMEN = OFF, IESO = OFF, PWRTEN = OFF, BOREN = OFF, BORV = 30
#pragma config WDTEN = OFF, WDTPS = 1, HFOFST = OFF
#pragma config MCLRE = OFF
#pragma config STVREN = ON, LVP = OFF, BBSIZ = OFF, XINST = OFF
#pragma config CP0 = OFF, CP1 = OFF, CPB = OFF, CPD = OFF, WRT0 = OFF
#pragma config WRT1 = OFF, WRTC = OFF, WRTB = OFF, WRTD = OFF
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTRB = OFF

#pragma udata access accessram
static unsigned near char g_temp1;
unsigned near char g_kana_cmt;
#pragma udata

/*
RA0 (D+)   USB
Ra1 (D-)   USB
RA3 (MCLR) For checking USB connection
RA4 (OSC2) crystal
RA5 (OSC1) crystal
RC0        CPLD (TCK)
RC1        CPLD (TMS)
RC2        Casette tape interface (connected to 18F14K22)
RC3        PS/2 (data)
RC4        CPLD (TDO) 
RC5	       PS/2 (clock)
RC6
RC7        CPLD (TDO)
RB4        CPLD (TDO)
RB5 (RX)   Serial connection to 18F14K22
RB6        CPLD (TCK)
RB7 (TX)   Serial connection to 18F14K22
*/

void main(){
	unsigned char i;
	OSCCON=0x08;
	// RB6, RB7 will be output
	TRISB=0x3F;
	ANSELHbits.ANS11=0;//RB5
	// RC3, RC5 will be I/O (initially, input), RC6 will be output
	TRISC=0xBF;
	ANSELbits.ANS7=0;//RC3
	LATCbits.LATC3=0;
	LATCbits.LATC5=0;
	LATCbits.LATC6=1; // LED is green.
	// Use Timer3 for generating 11.7 KHz signal
	T3CON=0x85;
	PIR2bits.TMR3IF=0;
	// Init eusart
	eusart_init();
	// Init ps/2 interface
	ps2_init();
	// misc
	debug_init();
	
	do {
		ps2_receive();
		eusart_events();
		// LED color setting
		if (g_kana_cmt&0x01) {
			// Orange
			LATCbits.LATC6=!LATCbits.LATC6;
		} else {
			// Green or Red
			LATCbits.LATC6=g_kana_cmt&0x04 ? 1:0;
		}
	} while(1);
}